int batteryCapacity = 2500;     //ємність батареї в mAh
float resistance = 10.0;     //величина потужного резистора
int cutoffVoltage = 1600;     //максимальна напруга батареї (в mV) яку не можна перевищувати
float cutoffTemperatureC = 35;     //максимальна температура батареї яку не можна перевищувати (в градусах C)
//float cutoffTemperatureF = 95;     //максимальна температура батареї яку не можна перевищувати (в градусах F)
long cutoffTime = 46800000;     //максимаьний час заряджання 13 годин який не варто перевищувати

int outputPin = 9;     // Вихідний сигнал на цифровому виході 9
int outputValue = 150;     //значення вихідного PWM сигналу 

int analogPinOne = 0;     //перший щуп для вимірювання напруги під'єднується до аналогового виводу 1 
float valueProbeOne = 0;     // змінна для зберігання значення analogPinOne
float voltageProbeOne = 0;     //обчислене значення напруги на виводі analogPinOne

int analogPinTwo = 1;     //другий щуп для вимірювання напруги під'єднується до аналогового виводу 2
float valueProbeTwo = 0;     //змінна для зберігання значення analogPinTwo
float voltageProbeTwo = 0;     //обчислене значення напруги на виводі analogPinTwo

int analogPinThree = 2;     //третій щуп для вимірювання напруги під'єднується до аналогового виводу 3
float valueProbeThree = 0;     //змінна для зберігання значення analogPinThree
float tmp36Voltage = 0;     //обчислене значення напруги на виводі analogPinThree
float temperatureC = 0;     //обчислене значення температури в С 
//float temperatureF = 0;     //обчислене значення температури в F

float voltageDifference = 0;     //різниця в вольтах між analogPinOne і analogPinTwo
float batteryVoltage = 0;     //обчислена напруга батареї
float current = 0;     //обчислений струм через навантаження (в mA)
float targetCurrent = batteryCapacity / 10;     //контрольний струм (в mA) встановлюється як C/10 або 1/10 від ємності батареї за годину
float currentError = 0;     //різниця між контрольним струмом і дійсним струмом (в mA)



void setup()
{
  Serial.begin(9600);     //  налаштування послідовного порту
  pinMode(outputPin, OUTPUT);     // налаштування виводу як вихідного
}



void loop()
{
    
  analogWrite(outputPin, outputValue);  //Запис вихідного значення на виводі 

  Serial.print("Output: ");     //відображення вихідного значення для контролю на компютері 
  Serial.println(outputValue); 

  valueProbeOne = analogRead(analogPinOne);    // читання вхідного значення на щупі один 
  voltageProbeOne = (valueProbeOne*5000)/1023;     //обчислення напруги на щупі один в мВ
  Serial.print("Voltage Probe One (mV): ");     //відображення напруги щупа один 
  Serial.println(voltageProbeOne);  
  
  valueProbeTwo = analogRead(analogPinTwo);    // читання вхідного значення на щупі два
  voltageProbeTwo = (valueProbeTwo*5000)/1023;     //обчислення напруги на щупі два в мВ
  Serial.print("Voltage Probe Two (mV): ");     //відображення напруги щупа два
  Serial.println(voltageProbeTwo);  
  
  batteryVoltage = 5000 - voltageProbeTwo;     //обчислення напруги батареї
  Serial.print("Battery Voltage (mV): ");     //відображення напруги батареї 
  Serial.println(batteryVoltage); 

  current = (voltageProbeTwo - voltageProbeOne) / resistance;     //обчислення зарядного струму 
  Serial.print("Target Current (mA): ");     //відображення зарядного струму
  Serial.println(targetCurrent);  
  Serial.print("Battery Current (mA): ");     //відображення вимірюваного значення струму
  Serial.println(current);  
      
  currentError = targetCurrent - current;     //різниця мід контрольним струмом і вимірюваним значенням струму
  Serial.print("Current Error  (mA): ");     //відображення помилки струму
  Serial.println(currentError);     

  valueProbeThree = analogRead(analogPinThree);    // читання вхідного значення на щупі три  
  tmp36Voltage = valueProbeThree * 5.0;     // конвертування прочитаного значення в напругу 
  tmp36Voltage /= 1024.0; 
 
  temperatureC = (tmp36Voltage - 0.5) * 100 ;     //конвертування 10 мВ на градус з 500 мВ зміщення  в градуси ((напруга - 500mV) * 100)
  Serial.print("Temperature (degrees C) ");     //відображення температури в градусах C
  Serial.println(temperatureC); 
 
 /*
  temperatureF = (temperatureC * 9.0 / 5.0) + 32.0;     //конвертування в Фаренгейти
  Serial.print("Temperature (degrees F) ");
  Serial.println(temperatureF); 
 */
 
  Serial.println();     //додаткові пробіли щоб полегшити сприйняття при читанні даних 
  Serial.println();  



  if(abs(currentError) > 10)     //якщо помилка струму досить велика - підлаштувати вихід 
   {
    outputValue = outputValue + currentError / 10;

    if(outputValue < 1)    //вихід ніколи не може бути нижче 0 
     {
      outputValue = 0;
     }

    if(outputValue > 254)     //вихід ніколи не може бути вище 255 
     {
      outputValue = 255;
     }
    
    analogWrite(outputPin, outputValue);     //записати нове значення на виході 
   }
 
 
  if(temperatureC > cutoffTemperatureC)     //зупинити заряджання якщо температура батареї первищить безпечний поріг 
   {
    outputValue = 0;
    Serial.print("Max Temperature Exceeded");
   }
   
  /*
  if(temperatureF > cutoffTemperatureF)     //зупинити заряджання якщо температура батареї первищить безпечне порігове значення
   {
    outputValue = 0;
   }
   */
   
   if(batteryVoltage > cutoffVoltage)     //зупинити заряджання якщо температура батареї перевищить безпечне порогове значенняstop 
   {
    outputValue = 0;
    Serial.print("Max Voltage Exceeded");
   }  
 
   if(millis() > cutoffTime)     //зупинити заряджання якщо перевищений пороговий час 
   {
    outputValue = 0;
    Serial.print("Max Charge Time Exceeded");
   }  

   delay(10000);     //зробити затримку перед наступною ітерацією 
}




